#!/usr/local/bin/tclsh

set opsys [ exec uname ]
if { $opsys == "SunOS" } {
    set version [ uname -r ]
    regexp {^[0-9]} $version major
    set opsys "$opsys-$major"
}

switch $opsys {
    IRIX {
	set arch irix5.3
    }
    SunOS-4 {
	set arch sunos4.1
    }
    SunOS-5 {
	set arch solaris2.5
    }
}

set env(KQML_HOME) /home/src/kqml/C/ver.2
set env(KQML_ARCH) $env(KQML_HOME)/ARCH/$arch

set env(KQML_DBG) $env(KQML_HOME)/log
set env(KQML_DBG_LEVEL) 11

set env(KQML_ROUTER) $env(KQML_ARCH)/bin/router
set env(KQML_VALIDATOR) $env(KQML_ARCH)/bin/validator

set env(KQML_ANS) "snoopy.cs.umbc.edu:5500:"

set env(SP_PATH) "$env(KQML_HOME)/lib/Runtime"
set env(PATH) "$env(PATH):$env(KQML_ARCH)/bin"
