#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <kqml.h>


int
main (int argc, char **argv)
{
  char *arg;
  int res;
  kqml_message *reply_msg = NULL;
  
  if (argc < 2)
    {
      arg = (char *) getlogin ();
    }
  else
    {
      arg = argv[1];
    }
  fprintf (stderr, "looking up: %s\n", arg);
  
  res = kqml_initialize ("sample_client", KQML_NOT_AN_ANS);
  if (res < 0) 
    {
      fprintf (stderr, "init returned %d\n", res);
      exit (-1);
    }
  
  res = kqml_send_msg (KQML_SEND_TIMEOUT, "ask-one", arg, "sample_server", "t", 
				&reply_msg, NULL);

  if (reply_msg)
    fprintf (stderr, "%s: %s\n",
	     reply_msg->performative,
	     kqml_get_field (":content", reply_msg, NULL, NULL));
  else
    fprintf (stderr, "Error: reply %d\n", res);
  fflush (stderr);
  
  fprintf (stderr, "\n\nAll Done\n\n");
  fflush (stderr);

  exit (1);
}
