/*
 * A kqml message contains a performative and an array of 
 * key/value pairs. A value_type is associated with each value.
 * Currently the value_type is only used to discriminate strings
 * and symbols. It may however be used more extensively later 
 * as the kqml parser is allowed to parse incoming KIF contents.
 *
 * The -connection- field in the message is used to carry around
 * the socket number associated with an incoming message to simply
 * the process of sending a synchronous reply back to that process.
 */


/* KQML expression types */
enum kqml_expression_type { 
	KQML_TYPE_UNKNOWN = 0, KQML_TYPE_WORD, KQML_TYPE_STRING,
		KQML_TYPE_BYTE, KQML_TYPE_QUOTED, KQML_TYPE_COMMA, 
		KQML_TYPE_SEXPR 
	};

struct kexpression
{
	string key<>;
	string value<>;
	kqml_expression_type value_type;
	int value_len;
	kexpression *next;
};

/* A kqml_message is a performative and an array of expressions */
struct kqml_message
{
	int connection;
	int parameter_count;
	string performative<>;
	kexpression *ppv;
};

struct ual
{
	string agent_name<>;
	string protocol<>;
	string host<>;
	int port;
};
